Index: trunk/sources/HeuristicLab.Optimization/3.3/HeuristicLab.Optimization-3.3.csproj
===================================================================
--- trunk/sources/HeuristicLab.Optimization/3.3/HeuristicLab.Optimization-3.3.csproj	(revision 6663)
+++ trunk/sources/HeuristicLab.Optimization/3.3/HeuristicLab.Optimization-3.3.csproj	(revision 6665)
@@ -111,4 +111,5 @@
   </ItemGroup>
   <ItemGroup>
+    <Compile Include="RunCollectionValueRemover.cs" />
     <Compile Include="IRunCollectionModifier.cs" />
     <None Include="HeuristicLabOptimizationPlugin.cs.frame" />
@@ -249,35 +250,5 @@
     </BootstrapperPackage>
   </ItemGroup>
-  <ItemGroup>
-    <Content Include="bin\x86\Debug\HeuristicLab.Collections-3.3.dll" />
-    <Content Include="bin\x86\Debug\HeuristicLab.Collections-3.3.pdb" />
-    <Content Include="bin\x86\Debug\HeuristicLab.Common-3.3.dll" />
-    <Content Include="bin\x86\Debug\HeuristicLab.Common-3.3.pdb" />
-    <Content Include="bin\x86\Debug\HeuristicLab.Common.Resources-3.3.dll" />
-    <Content Include="bin\x86\Debug\HeuristicLab.Common.Resources-3.3.pdb" />
-    <Content Include="bin\x86\Debug\HeuristicLab.Core-3.3.dll" />
-    <Content Include="bin\x86\Debug\HeuristicLab.Core-3.3.pdb" />
-    <Content Include="bin\x86\Debug\HeuristicLab.Data-3.3.dll" />
-    <Content Include="bin\x86\Debug\HeuristicLab.Data-3.3.pdb" />
-    <Content Include="bin\x86\Debug\HeuristicLab.Optimization-3.3.dll" />
-    <Content Include="bin\x86\Debug\HeuristicLab.Optimization-3.3.pdb" />
-    <Content Include="bin\x86\Debug\HeuristicLab.Parameters-3.3.dll" />
-    <Content Include="bin\x86\Debug\HeuristicLab.Parameters-3.3.pdb" />
-    <Content Include="bin\x86\Debug\HeuristicLab.Persistence-3.3.dll" />
-    <Content Include="bin\x86\Debug\HeuristicLab.Persistence-3.3.pdb" />
-    <Content Include="bin\x86\Debug\HeuristicLab.PluginInfrastructure-3.3.dll" />
-    <Content Include="bin\x86\Debug\HeuristicLab.PluginInfrastructure-3.3.pdb" />
-    <Content Include="bin\x86\Debug\HeuristicLab.Tracing-3.3.dll" />
-    <Content Include="bin\x86\Debug\HeuristicLab.Tracing-3.3.pdb" />
-    <Content Include="bin\x86\Debug\ICSharpCode.SharpZipLib License.txt" />
-    <Content Include="bin\x86\Debug\ICSharpCode.SharpZipLib.dll" />
-  </ItemGroup>
-  <ItemGroup>
-    <Folder Include="bin\Debug\" />
-    <Folder Include="bin\Release\" />
-    <Folder Include="bin\x64\Debug\" />
-    <Folder Include="bin\x64\Release\" />
-    <Folder Include="bin\x86\Release\" />
-  </ItemGroup>
+  <ItemGroup />
   <Import Project="$(MSBuildToolsPath)\Microsoft.CSharp.targets" />
   <!-- To modify your build process, add your task inside one of the targets below and uncomment it. 
Index: trunk/sources/HeuristicLab.Optimization/3.3/RunCollectionFuzzifier.cs
===================================================================
--- trunk/sources/HeuristicLab.Optimization/3.3/RunCollectionFuzzifier.cs	(revision 6663)
+++ trunk/sources/HeuristicLab.Optimization/3.3/RunCollectionFuzzifier.cs	(revision 6665)
@@ -13,4 +13,7 @@
   [StorableClass]
   public class RunCollectionFuzzifier : ParameterizedNamedItem, IRunCollectionModifier {
+
+    public override bool CanChangeName { get { return false; } }
+    public override bool CanChangeDescription { get { return false; } }
 
     #region Parameters
@@ -58,4 +61,5 @@
         }));
       RegisterEvents();
+      UpdateName();
     }
     public override IDeepCloneable Clone(Cloner cloner) {
Index: trunk/sources/HeuristicLab.Optimization/3.3/RunCollectionValueRemover.cs
===================================================================
--- trunk/sources/HeuristicLab.Optimization/3.3/RunCollectionValueRemover.cs	(revision 6665)
+++ trunk/sources/HeuristicLab.Optimization/3.3/RunCollectionValueRemover.cs	(revision 6665)
@@ -0,0 +1,49 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Parameters;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Optimization {
+
+  [Item("RunCollection Value Remover", "Modifies a RunCollection by removing results or parameters.")]
+  [StorableClass]
+  public class RunCollectionValueRemover : ParameterizedNamedItem, IRunCollectionModifier {
+    
+    public ValueParameter<CheckedItemCollection<StringValue>> ValuesParameter {
+      get { return (ValueParameter<CheckedItemCollection<StringValue>>)Parameters["Values"]; }
+    }
+
+    public IEnumerable<string> Values {
+      get { return ValuesParameter.Value.CheckedItems.Select(v => v.Value); }
+    }
+
+    #region Construction & Cloning    
+    [StorableConstructor]
+    protected RunCollectionValueRemover(bool deserializing) : base(deserializing) { }
+    protected RunCollectionValueRemover(RunCollectionValueRemover original, Cloner cloner)
+      : base(original, cloner) {
+    }
+    public RunCollectionValueRemover() {
+      Parameters.Add(new ValueParameter<CheckedItemCollection<StringValue>>("Values", "The result or parameter values to be removed from each run."));      
+    }
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new RunCollectionValueRemover(this, cloner);
+    }    
+    #endregion    
+
+    public void Modify(List<IRun> runs) {      
+      foreach (var run in runs) {
+        foreach (var value in Values) {
+          run.Parameters.Remove(value);
+          run.Results.Remove(value);
+        }        
+      }      
+    }
+    
+  }
+}